/***************************************************************************
 *   Copyright (C) 2008 by David Cuadrado   *
 *   krawek@gmail.com   *
 *                                                                         *
 *   Permission is hereby granted, free of charge, to any person obtaining *
 *   a copy of this software and associated documentation files (the       *
 *   "Software"), to deal in the Software without restriction, including   *
 *   without limitation the rights to use, copy, modify, merge, publish,   *
 *   distribute, sublicense, and/or sell copies of the Software, and to    *
 *   permit persons to whom the Software is furnished to do so, subject to *
 *   the following conditions:                                             *
 *                                                                         *
 *   The above copyright notice and this permission notice shall be        *
 *   included in all copies or substantial portions of the Software.       *
 *                                                                         *
 *   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,       *
 *   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF    *
 *   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. *
 *   IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR     *
 *   OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, *
 *   ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR *
 *   OTHER DEALINGS IN THE SOFTWARE.                                       *
 ***************************************************************************/

#include "application.h"

#include <QClipboard>
#include <QTimer>

#include <X11/Xlib.h>

Application::Application(int &argc, char **argv)
 : QApplication(argc, argv)
{
}

Application::~Application()
{
}

void Application::setBuffer(const QByteArray &data)
{
	m_buffer = data;
	clipboard()->setText(m_buffer);
}


void Application::close(int ms)
{
	QTimer::singleShot(ms, this, SLOT(quit()));
}

Application *Application::self()
{
	return static_cast<Application *>(qApp);
}

bool Application::x11EventFilter( XEvent * event )
{
	if(!m_buffer.isEmpty())
	{
		clipboard()->setText(m_buffer);
		m_buffer = QByteArray();
	}
	
	return QApplication::x11EventFilter(event);
}
